#!/usr/bin/perl

die "Invalid number of arguments.  Usage:\n$0 <match-exp> <trans-exp> [<filename> [ ... ]]" if $#ARGV < 1;

my $expr = "\$? = s/" . $ARGV[0] . "/" . $ARGV[1] . "/g;";
my $ret = 0;

$verbose = 0;


sub PrintSometimes { if($verbose) { print shift; } }

sub RenameIfMatches {
  my $o = shift;
  $_ = $o;

  eval $expr;

  if($? == 0) {
    PrintSometimes("$o - No match\n");
  } elsif(/^$/) {
    PrintSometimes("$o - Null result\n");
  } else {
    PrintSometimes("$o - Rename to $_\n");
    rename($o, $_);
  }

  return $?;
}


if($#ARGV > 1) {
  for($i = 2; $i <= $#ARGV; $i++) {
    $ret += RenameIfMatches($ARGV[$i]) ? 1 : 0;
  }
} else {
  PrintSometimes("Applying rule to all files in current directory.\n");

  opendir(DIR, ".") or die "Couldn't open directory";
  @FILES = readdir(DIR);
  closedir(DIR);

  foreach $d (@FILES) {
    next if $d =~ /^[\.]+$/;
    $ret += RenameIfMatches($d) ? 1 : 0;
  }
}

exit $ret;
